// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Fixtures.MirrorPrimitives.Models
{
    using System.Linq;

    public partial class Product
    {
        /// <summary>
        /// Initializes a new instance of the Product class.
        /// </summary>
        public Product() { }

        /// <summary>
        /// Initializes a new instance of the Product class.
        /// </summary>
        /// <param name="enumProperty">Possible values include: 'red', 'blue',
        /// 'green'</param>
        public Product(int? integer = default(int?), int? intProperty = default(int?), long? longProperty = default(long?), double? number = default(double?), double? floatProperty = default(double?), double? doubleProperty = default(double?), byte[] byteProperty = default(byte[]), string stringProperty = default(string), byte[] base64url = default(byte[]), System.Guid? uuid = default(System.Guid?), string enumProperty = default(string), bool? boolean = default(bool?), System.DateTime? date = default(System.DateTime?), System.DateTime? dateTime = default(System.DateTime?), System.Collections.Generic.IList<int?> integerArray = default(System.Collections.Generic.IList<int?>), System.Collections.Generic.IList<int?> intArray = default(System.Collections.Generic.IList<int?>), System.Collections.Generic.IList<long?> longArray = default(System.Collections.Generic.IList<long?>), System.Collections.Generic.IList<double?> numberArray = default(System.Collections.Generic.IList<double?>), System.Collections.Generic.IList<double?> floatArray = default(System.Collections.Generic.IList<double?>), System.Collections.Generic.IList<double?> doubleArray = default(System.Collections.Generic.IList<double?>), System.Collections.Generic.IList<byte[]> byteArray = default(System.Collections.Generic.IList<byte[]>), System.Collections.Generic.IList<bool?> booleanArray = default(System.Collections.Generic.IList<bool?>), System.Collections.Generic.IList<string> stringArray = default(System.Collections.Generic.IList<string>), System.Collections.Generic.IList<byte[]> base64urlArray = default(System.Collections.Generic.IList<byte[]>), System.Collections.Generic.IList<System.DateTime?> dateArray = default(System.Collections.Generic.IList<System.DateTime?>), System.Collections.Generic.IList<System.DateTime?> dateTimeArray = default(System.Collections.Generic.IList<System.DateTime?>), System.Collections.Generic.IList<System.Guid?> uuidArray = default(System.Collections.Generic.IList<System.Guid?>))
        {
            Integer = integer;
            IntProperty = intProperty;
            LongProperty = longProperty;
            Number = number;
            FloatProperty = floatProperty;
            DoubleProperty = doubleProperty;
            ByteProperty = byteProperty;
            StringProperty = stringProperty;
            Base64url = base64url;
            Uuid = uuid;
            EnumProperty = enumProperty;
            Boolean = boolean;
            Date = date;
            DateTime = dateTime;
            IntegerArray = integerArray;
            IntArray = intArray;
            LongArray = longArray;
            NumberArray = numberArray;
            FloatArray = floatArray;
            DoubleArray = doubleArray;
            ByteArray = byteArray;
            BooleanArray = booleanArray;
            StringArray = stringArray;
            Base64urlArray = base64urlArray;
            DateArray = dateArray;
            DateTimeArray = dateTimeArray;
            UuidArray = uuidArray;
        }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "integer")]
        public int? Integer { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "int")]
        public int? IntProperty { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "long")]
        public long? LongProperty { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "number")]
        public double? Number { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "float")]
        public double? FloatProperty { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "double")]
        public double? DoubleProperty { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "byte")]
        public byte[] ByteProperty { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "string")]
        public string StringProperty { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonConverter(typeof(Microsoft.Rest.Serialization.Base64UrlJsonConverter))]
        [Newtonsoft.Json.JsonProperty(PropertyName = "base64url")]
        public byte[] Base64url { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "uuid")]
        public System.Guid? Uuid { get; set; }

        /// <summary>
        /// Gets or sets possible values include: 'red', 'blue', 'green'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "enum")]
        public string EnumProperty { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "boolean")]
        public bool? Boolean { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonConverter(typeof(Microsoft.Rest.Serialization.DateJsonConverter))]
        [Newtonsoft.Json.JsonProperty(PropertyName = "date")]
        public System.DateTime? Date { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "dateTime")]
        public System.DateTime? DateTime { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "integerArray")]
        public System.Collections.Generic.IList<int?> IntegerArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "intArray")]
        public System.Collections.Generic.IList<int?> IntArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "longArray")]
        public System.Collections.Generic.IList<long?> LongArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "numberArray")]
        public System.Collections.Generic.IList<double?> NumberArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "floatArray")]
        public System.Collections.Generic.IList<double?> FloatArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "doubleArray")]
        public System.Collections.Generic.IList<double?> DoubleArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "byteArray")]
        public System.Collections.Generic.IList<byte[]> ByteArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "booleanArray")]
        public System.Collections.Generic.IList<bool?> BooleanArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "stringArray")]
        public System.Collections.Generic.IList<string> StringArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "base64urlArray")]
        public System.Collections.Generic.IList<byte[]> Base64urlArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "dateArray")]
        public System.Collections.Generic.IList<System.DateTime?> DateArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "dateTimeArray")]
        public System.Collections.Generic.IList<System.DateTime?> DateTimeArray { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "uuidArray")]
        public System.Collections.Generic.IList<System.Guid?> UuidArray { get; set; }

    }
}
