# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from .resource import Resource


class FlattenedProduct(Resource):
    """FlattenedProduct.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :ivar id: Resource Id
    :vartype id: str
    :ivar type: Resource Type
    :vartype type: str
    :param tags:
    :type tags: dict
    :param location: Resource Location
    :type location: str
    :ivar name: Resource Name
    :vartype name: str
    :param pname:
    :type pname: str
    :param lsize:
    :type lsize: int
    :param provisioning_state:
    :type provisioning_state: str
    """ 

    _validation = {
        'id': {'readonly': True},
        'type': {'readonly': True},
        'name': {'readonly': True},
    }

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'location': {'key': 'location', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'pname': {'key': 'properties.pname', 'type': 'str'},
        'lsize': {'key': 'properties.lsize', 'type': 'int'},
        'provisioning_state': {'key': 'properties.provisioningState', 'type': 'str'},
    }

    def __init__(self, tags=None, location=None, pname=None, lsize=None, provisioning_state=None):
        super(FlattenedProduct, self).__init__(tags=tags, location=location)
        self.pname = pname
        self.lsize = lsize
        self.provisioning_state = provisioning_state
